package com.ecommerce.ccScrubbing.util

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

class Application {

	protected Properties props
	protected Logger logger
	
	/**
	 * Constructor which reads the configuration and then creates dependencies
	 */
	Application(){
		startLogger()
		readConfiguration()
		createDependencies()
	}

	/**
	 * Create a logger for the application
	 */
	private void startLogger(){
		logger = LoggerFactory.getLogger("com.ecommerce.ccScrubbing")
	}
	
	/**
	 * Read Configuration file from the classpath
	 */
	private void readConfiguration(){
		//load configuration from config file
		props = new Properties()
		URL url = ClassLoader.getSystemResource("config.properties");

        if(!url){
        	 
        	//throw new Exception("Unable to load config.properties")
        	logger.error ("Unable to load config.properties {}", url.toString())
        	
        }else{
        	props.load(url.openStream())
        	logger.info("Read Configuration file - environment is {}", props.env)
        } 
	}
	
	/**
	 * Create Application Dependencies
	 */
	protected void createDependencies(){
		logger.info "Created Dependencies"
	}

	public static void main(String[] args){
		new Application()
	}	
}
